--include "menu.lua"
--include "errorHandler.lua"

do game=process()
	local score=0
	local highscore=0
	
	local scale=10
	local x=dispX/2
	
	local xSpeedMax=300
	local xSpeed=0
	local rstYSpeed=200
	local ySpeed=200
	local yAccel=15
	
	local tunnel={}
	
	local minX=dispX/6
	local maxX=dispX*5/6
	
	local pxlTillNext=10
	
	local tunPos=0
	
	local dir="left"
	
	local pWidth=scale
	
	function genValue()
		local tmp=3
		if dir=="right" then
			tmp=2
		end
		tunPos=tunPos+(math.random(1, 4)-tmp)/2
		if tunPos<gameWidth(score+#tunnel*scale)/2 then
			tunPos=gameWidth(score+#tunnel*scale)/2
			dir="right"
		elseif tunPos>(maxX-minX)/scale-gameWidth(score+#tunnel*scale)/2 then
			tunPos=(maxX-minX)/scale-gameWidth(score+#tunnel*scale)/2
			dir="left"
		end
	end
	
	function gameWidth(s)
		local tmp=(maxX-minX)/scale-s/(20*scale)
		if tmp<65/scale then
			tmp=65/scale
		end
		return tmp
	end
	
	function die()
		if score>highscore then
			highscore=score
			document.markChanged()
		end
		PullProcess()
		PushProcess(deathScreen)
	end
	
	function game:paint(gc)
		gc:setColorRGB(0x000000)
		gc:fillRect(0,0,dispX,dispY)
		gc:setColorRGB(0xFFFFFF)
		for i=1, #tunnel do
			local tunWidth=gameWidth(score+i*scale)
			gc:fillRect(minX+tunnel[i]*scale-tunWidth*scale/2, dispY-(i*scale-score%scale), tunWidth*scale, scale)
		end
		gc:drawString(""..math.floor(score), 0, 0)
		gc:setColorRGB(0x7F7F7F)
		gc:fillRect(x-pWidth/2, dispY-pWidth, pWidth, pWidth)
	end
	
	function game:timer()
		local mil=millis()-self.lastRun
		local fac=mil/1000
		
		score=score+ySpeed*fac
		ySpeed=ySpeed+yAccel*fac
		if x<minX then
			x=minX
		elseif x>maxX then
			x=maxX
		end
		pxlTillNext=pxlTillNext-ySpeed*fac
		while pxlTillNext<=0 do
			genValue()
			table.remove(tunnel,1)
			table.insert(tunnel, tunPos)
			pxlTillNext=pxlTillNext+scale
		end
		if (x-minX)/scale<tunnel[1]-gameWidth(score)/2 or (x-minX)/scale>tunnel[1]+gameWidth(score)/2 then
			die()
		end
		disp:invalidate()
	end
	
	function rstTunnel()
		tunnel={}
		for i=1, math.ceil(dispY/scale) do
			tunnel[i]=(maxX-minX)/scale/2
		end
	end
	
	function game:Open()
		timer.start(1/50)
		score=0
		ySpeed=rstYSpeed
		x=dispX/2
		rstTunnel()
		tunPos=tunnel[#tunnel]
		pxlTillNext=10
	end
	
	function game:Close()
		timer.stop()
	end
	
	function game:escapeKey()
		PullProcess()
	end
	
	function move(mult)
		x=x+xSpeedMax*mult/20
	end
	
	function game:arrowKey(key)
		if key=="right" then
			move(1)
		elseif key=="left" then
			move(-1)
		end
	end
	
	function game:charIn(c)
		if c=='4' then
			move(-1)
		elseif c=='6' then
			move(1)
		end
	end
	
	do deathScreen=process()
		function deathScreen:paint(gc)
			gc:setColorRGB(0x000000)
			gc:fillRect(0,0,dispX,dispY)
			gc:setColorRGB(0xFFFFFF)
			gc:setFont("serif", "r", 16)
			centerText(gc, "You crashed!", dispX/2, gc:getStringHeight("You crashed!")/2)
			centerText(gc, "Your score is: "..math.floor(score), dispX/2, dispY/2)
			centerText(gc, "Your highscore is: "..math.floor(highscore), dispX/2, dispY-gc:getStringHeight("Your highscore is: "..highscore)/2)
		end
		
		function deathScreen:Open()
			menu:deactivate()
			disp:invalidate()
		end
		
		function deathScreen:mouseDown()
			PullProcess()
		end
		
		function deathScreen:escapeKey()
			PullProcess()
		end
		
		function deathScreen:enterKey()
			PullProcess()
		end
		
		function deathScreen:clearKey()
			highscore=0
		end
	end
	
	function game:getHighscore()
		return highscore
	end
	
	function game:setHighscore(s)
		if s~=nil then
			highscore=s
		end
	end
	
	function game:recovery()
		if tunnel==nil or #tunnel<math.ceil(dispY/scale) then
			rstTunnel()
		end
	end
end

function on.save()
	return game:getHighscore()
end

function on.restore(arg)
	game:setHighscore(arg)
end

function on.construction()
	readme:setText("NTunnel\n\nContents:\n1. Gameplay\n2. Controls\n3. Credits\n\n1. Gameplay:\nIn tunnel the goal is to stay in the white area. \nYou move left or right to stay in it. \nAs the game progresses, it goes faster and faster and the white area gets thinner.\n\n2. Controls:\nUse the right and left arrow keys to move left or right. You can also press 4 to move left and 6 to move right.\n\n3. Credits:\nThis game was made by semiprocoder. You can contact me at andyhsstudent@gmail.com")
	menu:add("play", game)
	menu:add("readme", readme)
	menu:setTitle("NTunnel")
	PushProcess(menu)
end